<img src="https://github.com/Shopify/shopify-cli/raw/main/assets/logo.png" alt="Shopify logo" width="150">

# Contributors documentation

You can learn about [how to contribute](./introduction), read about
[CLI kit](./Kit:-Introduction), or learn about the rationale underlying some of
our biggest decisions.

* [Get started](./get-started.md)
* [Architecture](./architecture.md)
* [Conventions](./conventions.md)
* [Debugging](./debugging.md)
* [ESLint rules](./eslint-rules.md)
* [Principles](./principles.md)
* [Release process](./release.md)
* [Testing strategy](./testing-strategy.md)
* [Troubleshooting](./troubleshooting.md)
* [Plugins](./plugins.md)
* [FAQ](./faq.md)

## Plugins
* [Ngrok tunnel](./plugins/ngrok.md)


## Decision Record
* [August 2022 - Automating via Nx](./decision-record/2022_08-automation-via-nx.md)
* [May 2022 - IDs' persistence](./decision-record/2022_05-IDs'-persistence.md)
* [March 2022 - Lazy downloading a fixed version of the extension binary](./decision-record/2022_03-Lazy-downloading-a-fixed-version-of-the-extension-binary.md)
* [March 2022 - Configuration source of truth](./decision-record/2022_03-Configuration-source-of-truth.md)
* [February 2022 - Incremental builds with Nx](./decision-record/2022_02-Incremental-builds-with-Nx.md)
* [February 2022 - ESM, Rollup, and Vitest](./decision-record/2022_02-ESM,-Rollup,-and-Vitest.md)
* [January 2022 - Unified dependency graph](./decision-record/2022_01-unified-dependency-graph.md)
* [January 2022 - TypeScript rewrite](./decision-record/2022_01-TypeScript-rewrite.md)
